package com.muyu.cache.abs;

import com.muyu.cache.redis.Cache;
import com.muyu.common.redis.service.RedisService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @ClassName CacheAbs
 * @Description 描述
 * @Author SaiSai.Liu
 * @Date 2024/5/14 17:05
 */

//@Component
public abstract class CacheAbs<K, V extends List<?>> implements Cache<K> {

//    @Autowired
    private RedisService redisService;

    @Autowired
    public CacheAbs(RedisService redisService) {
        this.redisService = redisService;
    }

    /**
     * 根据key获取值
     *
     * @param key
     * @return
     */
    public List<V> get(K key) {
        List<V> v = redisService.getCacheList(String.valueOf(key));
        if (v != null) {
            return v;
        }
        return null;
    }

    /**
     * 存入值
     *
     * @param k
     * @param v
     */
    public void put(K k, V v) {
        String key = enCode(k);
        redisService.setCacheList(key, v);
    }

    /**
     * 删除值
     *
     * @param k
     */
    void remove(K k) {
        redisService.deleteObject(enCode(k));
    }

    ;
}
