package com.muyu.scope.engine.scope;


import com.muyu.scope.engine.Engine;
import com.muyu.scope.model.DataSetModel;
import com.muyu.scope.scope.DataSetContext;
import com.muyu.scope.scope.model.DataSetProcessModel;
import lombok.Data;

/**
 * 数据模型引擎接口
 * @Author: DongZeLiang
 * @date: 2024/5/6
 * @Description: 数据模型引擎接口
 * @Version: 1.0
 */
@Data
public abstract class DataSetEngine implements Engine<DataSetProcessModel> {
    //上下文对象
    private DataSetContext dataSetContext;

    @Override
    public DataSetProcessModel get() {
        return dataSetContext.get();
    }

    public DataSetModel getModel(){
        return get().getDataSetModel();
    }

}
