package com.muyu.etl.util.service;

import com.alibaba.druid.pool.DruidDataSource;
import com.alibaba.druid.pool.DruidPooledConnection;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * @ClassName PoolFactory
 * @Description 描述
 * @Author SaiSai.Liu
 * @Date 2024/5/10 16:28
 */
public interface ConnectionPoolFactory<T> {
    /**
     * 根据所给信息构造连接池并存入大池
     * @param t
     * @return
     * @throws SQLException
     */
    public DruidDataSource init(T t) throws SQLException;

    public Connection getConnection(T t) throws SQLException;

    public void giveBack() throws SQLException;

}
