package com.muyu;

import com.muyu.cache.AssetCache;
import com.muyu.common.redis.service.RedisService;
import com.muyu.etl.domain.BasicConfigInfo;
import com.muyu.etl.service.BasicConfigInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.servlet.ServletException;
import java.util.List;
import java.util.concurrent.TimeUnit;

/**
 * @ClassName EtlApplicationRunner
 * @Description 描述
 * @Author SaiSai.Liu
 * @Date 2024/5/14 20:54
 */
@Component
public class EtlApplicationRunner implements ApplicationRunner {
    @Autowired
    private BasicConfigInfoService basicConfigInfoService;

    @Autowired
    private RedisService redisService;


    @Autowired
    private AssetCache assetCache ;


    @Override
    public void run(ApplicationArguments args) throws Exception {
        List<BasicConfigInfo> basicConfigInfos = basicConfigInfoService.selectBasicConfigInfoList(new BasicConfigInfo() {{
            setIsTest("1");
        }});
        assetCache.put("basic", basicConfigInfos);
    }

    @Scheduled(zone = "0 0/10 * * * ? *")
    public void delay(){
        if (!redisService.hasKey(assetCache.preKey()+"basic")) try {
            throw new ServletException("过期了");
        } catch (ServletException e) {
            throw new RuntimeException(e);
        }
        redisService.expire(assetCache.preKey()+"basic",10, TimeUnit.MINUTES);
    }
}
